package com.yifu.cloud.plus.v1.yifu.process.util;


import com.yifu.cloud.plus.v1.yifu.admin.api.entity.SysUser;
import com.yifu.cloud.plus.v1.yifu.common.core.constant.CommonConstants;
import com.yifu.cloud.plus.v1.yifu.common.core.exception.CheckedException;
import com.yifu.cloud.plus.v1.yifu.common.core.util.Common;
import com.yifu.cloud.plus.v1.yifu.process.entity.TNodePrimission;

import java.util.ArrayList;
import java.util.List;

/**
 * @author chenyuxi
 * @date 2020/9/22
 * 通用流程工具类
 */
public class CommonProcessUserUtil {

    private CommonProcessUserUtil() {
    }

    public static final String FEGIN_USER_FAIL = "调用用户服务失败";
    public static final String FEGIN_USER_RETURN_FAIL = "调用用户服务回失败";


    /**
     * 获取crm部门审核人
	 * @param nodePrimission
     * @param departId
     * @return List<SysUser>
     **/
    public static List<SysUser> getDepartAuditUser(TNodePrimission nodePrimission, String departId) {
        SysUser remoteSysUser = null;
        List<SysUser> remoteSysUserList = new ArrayList<>();
        if (CommonConstants.THREE_INT == nodePrimission.getType().intValue()) {
            //3.指定用户
            if (Common.isEmpty(nodePrimission.getUser())) {
                throw new CheckedException("未查询当前流程权限对应的用户");
            }
            // 查找当前用户
            // todo 通过用户id查询用户角色
            // remoteSysUser = RemoteRequestUtil.getSysUser(remoteUserService, Integer.parseInt(nodePrimission.getUser()));
            remoteSysUserList.add(remoteSysUser);
        } else if (CommonConstants.TWO_INT == nodePrimission.getType().intValue()) {
            //2.指定角色
            if (Common.isEmpty(nodePrimission.getRole())) {
                throw new CheckedException("未查询当前流程对应的组织权限");
            }
            //如果下个节点是角色这要取下个角色是否存在
            // remoteSysUser = RemoteRequestUtil.getUserManagerByRoleAndDepartId(remoteUserService, departId, nodePrimission.getRole());
            remoteSysUserList.add(remoteSysUser);
        } else if (CommonConstants.FIVE_INT == nodePrimission.getType().intValue()){
            // 5.指定角色(crm)
            if (Common.isEmpty(nodePrimission.getApprovalRole())) {
                throw new CheckedException("未查询当前节点配置的审核角色");
            }
            // remoteSysUserList = RemoteRequestUtil.getUserByRoleIdForCrm(remoteUserService, departId, nodePrimission.getApprovalRole());
        }
        return remoteSysUserList;
    }
}
