package com.yifu.cloud.plus.v1.yifu.salary.service.impl.process;

import com.baomidou.mybatisplus.core.conditions.update.LambdaUpdateWrapper;
import com.baomidou.mybatisplus.core.toolkit.Wrappers;
import com.yifu.cloud.plus.v1.yifu.admin.api.entity.SysUser;
import com.yifu.cloud.plus.v1.yifu.common.core.constant.CommonConstants;
import com.yifu.cloud.plus.v1.yifu.common.core.constant.ResultConstants;
import com.yifu.cloud.plus.v1.yifu.common.core.exception.CheckedException;
import com.yifu.cloud.plus.v1.yifu.common.core.util.Common;
import com.yifu.cloud.plus.v1.yifu.common.core.util.R;
import com.yifu.cloud.plus.v1.yifu.common.core.vo.YifuUser;
import com.yifu.cloud.plus.v1.yifu.process.constant.ProcessConstants;
import com.yifu.cloud.plus.v1.yifu.process.entity.TNodePrimission;
import com.yifu.cloud.plus.v1.yifu.process.entity.TNodeRoute;
import com.yifu.cloud.plus.v1.yifu.process.entity.TNodeRouteCondition;
import com.yifu.cloud.plus.v1.yifu.process.entity.TProcessNode;
import com.yifu.cloud.plus.v1.yifu.process.util.ProcessAuditUtil;
import com.yifu.cloud.plus.v1.yifu.process.vo.ProcessVo;
import com.yifu.cloud.plus.v1.yifu.salary.entity.TAuditNodeProocess;
import com.yifu.cloud.plus.v1.yifu.salary.entity.TAuditRecord;
import com.yifu.cloud.plus.v1.yifu.salary.entity.TInsuranceUnpurchaseApply;
import com.yifu.cloud.plus.v1.yifu.salary.entity.TInsuranceUnpurchasePerson;
import com.yifu.cloud.plus.v1.yifu.salary.service.TInsuranceUnpurchaseApplyService;
import com.yifu.cloud.plus.v1.yifu.salary.service.TInsuranceUnpurchasePersonService;
import com.yifu.cloud.plus.v1.yifu.salary.service.impl.AbastractAuditProcess;
import com.yifu.cloud.plus.v1.yifu.salary.vo.TInsuranceUnpurchaseApplySearchVo;
import org.apache.commons.lang.StringUtils;
import org.springframework.stereotype.Component;
import org.springframework.web.client.RestTemplate;

import javax.annotation.Resource;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

/**
 * @auther wangan
 * @date 2021/4/26
 * 商机审核
 */
@Component
public class TInsuranceUnpurchaseApplyAuditProcess extends AbastractAuditProcess<TInsuranceUnpurchaseApply, TInsuranceUnpurchaseApplySearchVo> {

	@Resource
	private TInsuranceUnpurchaseApplyService tInsuranceUnpurchaseApplyService;

	@Resource
	private TInsuranceUnpurchasePersonService personService;

    @Override
    public R<String> auditSuccess(TInsuranceUnpurchaseApply entity, TAuditRecord approvalRecord, YifuUser loginUser) {
    	// 改实体审核状态为审核通过
        entity.setAuditFlag(CommonConstants.THREE_STRING);
        entity.setAuditUser("");
		entity.setAuditUserId("");
        boolean res = tInsuranceUnpurchaseApplyService.updateById(entity);
        if (res) {
            // todo 删除当前实体所有的流程节点，数据量太大影响审批效率
            // 防止死锁，先查询再删除
            TAuditNodeProocess auditNodeProocessInfo = auditNodeProocessService.getOne(Wrappers.<TAuditNodeProocess>query().lambda()
                    .eq(TAuditNodeProocess::getDomainId, entity.getId())
                    .in(TAuditNodeProocess::getType, approvalRecord.getAuditType())
                    .last(CommonConstants.SQL_LIMIT_ONE));
            if(Common.isNotKong(auditNodeProocessInfo)) {
                auditNodeProocessService.remove(Wrappers.<TAuditNodeProocess>query().lambda().eq(TAuditNodeProocess::getDomainId, entity.getId())
                        .in(TAuditNodeProocess::getType, approvalRecord.getAuditType()));
            }

			//huych--更新明细审核状态
			LambdaUpdateWrapper<TInsuranceUnpurchasePerson> updateWrapper = new LambdaUpdateWrapper<>();
			updateWrapper.eq(TInsuranceUnpurchasePerson::getParnetId,entity.getId())
					.set(TInsuranceUnpurchasePerson::getStatus, entity.getStatus());
			personService.update(updateWrapper);
        }

        return R.ok("审核通过");
    }

    @Override
    public R<String> auditSuccessAndNex(TInsuranceUnpurchaseApply entity, List<SysUser> remoteSysUserList, TAuditRecord approvalRecord) {
        return R.ok("审核通过");
    }

    @Override
    public R<String> auditFail(TInsuranceUnpurchaseApply entity, TAuditRecord approvalRecord) {
		// 以后有抄送再加逻辑：参照crm-更改之前抄送记录状态为0
		// 改实体审核状态为审核不通过
		entity.setAuditFlag(CommonConstants.FOUR_STRING);
		entity.setAuditUser("");
		entity.setAuditUserId("");
		tInsuranceUnpurchaseApplyService.updateById(entity);

		// todo 删除当前实体所有的流程节点，数据量太大影响审批效率
		// 防止死锁，先查询再删除
		TAuditNodeProocess auditNodeProocessInfo = auditNodeProocessService.getOne(Wrappers.<TAuditNodeProocess>query().lambda()
				.eq(TAuditNodeProocess::getDomainId, entity.getId())
				.in(TAuditNodeProocess::getType, approvalRecord.getAuditType())
				.last(CommonConstants.SQL_LIMIT_ONE));
		if(Common.isNotKong(auditNodeProocessInfo)) {
			auditNodeProocessService.remove(Wrappers.<TAuditNodeProocess>query().lambda()
					.eq(TAuditNodeProocess::getDomainId, entity.getId())
					.in(TAuditNodeProocess::getType, approvalRecord.getAuditType()));
		}

		return R.ok("审核成功");
    }

    @Override
    public TProcessNode choiceGetNode(ProcessVo processVo, List<TNodeRoute> nodeRouteList, List<TNodeRouteCondition> nodeRouteConditionList,
									  TProcessNode currentNode, TInsuranceUnpurchaseApply entity, String type, YifuUser loginUser) {
        // 根据不购买原因判断 1 已购买社保 2 人员已离职选择
        if (StringUtils.equals(ProcessConstants.PROCESS_NODE_INSURANCEUNPURCHASE_REASON_TYPE,currentNode.getName())){
            TNodeRoute nodeRoute = ProcessAuditUtil.getTNodeRoteByExpress(nodeRouteList, nodeRouteConditionList, entity.getReasonType(), null);
            saveNodeProcess(processVo, nodeRoute.getNextNode(), entity.getId(), type);

            return validateTwoNextNode(processVo, nodeRoute.getNextNode(), entity.getId(), nodeRoute.getRouteType(), type, entity, loginUser);
        }else if (StringUtils.equals(ProcessConstants.PROCESS_NODE_INSURANCEUNPURCHASE_DEPT_PROPERTY,currentNode.getName())){
            // 根据申请部门 是否属于子分公司
            TNodeRoute nodeRoute = ProcessAuditUtil.getTNodeRoteByExpress(nodeRouteList, nodeRouteConditionList, entity.getCompanyFlag(), null);
            saveNodeProcess(processVo, nodeRoute.getNextNode(), entity.getId(), type);

            return validateTwoNextNode(processVo, nodeRoute.getNextNode(), entity.getId(), nodeRoute.getRouteType(), type, entity, loginUser);
        } else{
            throw new CheckedException("未知的条件节点类型,请联系管理员");
        }
    }

    @Override
    public R<String> sendMessage(List<SysUser> users, TInsuranceUnpurchaseApply entity, String type, TAuditRecord approvalRecord) {
        sendMessageToWx(users,entity,type, approvalRecord);
        return R.ok(null, ResultConstants.SUCCESS_INFO);
    }

	/**
	 * 根据事业部条线获取审批用户
	 * @param nodePrimission
	 * @param entity
	 * @return List<SysUser>
	 **/
	@Override
	public List<SysUser> getDivisionAuditUser(TNodePrimission nodePrimission, TInsuranceUnpurchaseApply entity) {
		SysUser remoteSysUser = null;
		List<SysUser> remoteSysUserList = new ArrayList<>();
		if (CommonConstants.SIX_INT == nodePrimission.getType().intValue()) {
			 // 6.指定事业部审批
			 if (Common.isEmpty(nodePrimission.getDivisionIdentification())) {
				 throw new CheckedException("未查询当前节点配置的事业部审批人标识");
			 }
			 // todo 根据配置条件查找用户
			// remoteSysUserList = RemoteRequestUtil.getUserByDivisionConfig(remoteUserService, advancePaymentEntity.getDivision(), advancePaymentEntity.getDivisionLine(), nodePrimission.getDivisionIdentification());
		}
		return remoteSysUserList;
	}

    /**
     * 功能描述: 企业微信发送通知
     * @Param: [users, customerContract, type 发送提示类型 1审批 2抄送]
     */
    private void sendMessageToWx(List<SysUser> users, TInsuranceUnpurchaseApply insuranceUnpurchaseApply, String type, TAuditRecord approvalRecord) {

            StringBuilder sendUser = null;
            for (SysUser user : users) {
                if (Common.isNotKong(user.getWxMessage())) {
                    if (sendUser == null) {
                        sendUser = new StringBuilder(user.getWxMessage());
                    } else {
                        sendUser = sendUser.append("|").append(user.getWxMessage());
                    }
                }

            }
            if (sendUser != null) {
                RestTemplate restTemplate = new RestTemplate();
                Map<String, Object> requestMap = new HashMap<>();
                Map<String, Object> textcard = new HashMap<>();

				textcard.put("title", "含风险项目不购买商险申请");
				// todo
				textcard.put("page", "pages/sale/page/businessAuditDetail/businessAuditDetail?businessId="+insuranceUnpurchaseApply.getId());
				// todo
                textcard.put("appid", "111");
                textcard.put("emphasis_first_item", false);

                List<Map<String,String>> contentItemList = new ArrayList<>();

                Map<String,String> contentItemMap = new HashMap<>();
                contentItemMap.put("key", "申请人：");
                contentItemMap.put("value", insuranceUnpurchaseApply.getCreateName().length()>CommonConstants.THIRTY_INT?insuranceUnpurchaseApply.getCreateName().substring(CommonConstants.ZERO_INT,CommonConstants.TWENTY_SEVEN_INT)+"...":insuranceUnpurchaseApply.getCreateName());
                contentItemList.add(contentItemMap);

                contentItemMap = new HashMap<>();
				contentItemMap.put("key", "项目编码：");
				contentItemMap.put("value", insuranceUnpurchaseApply.getDeptNo());
				contentItemList.add(contentItemMap);

				contentItemMap = new HashMap<>();
				contentItemMap.put("key", "项目名称：");
				contentItemMap.put("value", insuranceUnpurchaseApply.getDeptName().length()>CommonConstants.THIRTY_INT?insuranceUnpurchaseApply.getDeptName().substring(CommonConstants.ZERO_INT,CommonConstants.TWENTY_SEVEN_INT)+"...":insuranceUnpurchaseApply.getDeptName());
				contentItemList.add(contentItemMap);

				// 不购买原因 1 已购买社保 2 人员已离职
				Map<String,String> reasonTypeMap = new HashMap<>();
				reasonTypeMap.put("1", "已购买社保");
				reasonTypeMap.put("2", "人员已离职");
				contentItemMap = new HashMap<>();
				contentItemMap.put("key", "不购买原因：");
				contentItemMap.put("value", reasonTypeMap.get(insuranceUnpurchaseApply.getReasonType()));
				contentItemList.add(contentItemMap);

				contentItemMap = new HashMap<>();
				contentItemMap.put("key", "不购买人数：");
				contentItemMap.put("value", insuranceUnpurchaseApply.getUnbuyNum());
				contentItemList.add(contentItemMap);

                textcard.put("content_item", contentItemList);

                requestMap.put("touser", sendUser);
                requestMap.put("msgtype", "miniprogram_notice");
                requestMap.put("miniprogram_notice", textcard);
                requestMap.put("enable_id_trans", 0);
                requestMap.put("enable_duplicate_check", 0);
                requestMap.put("duplicate_check_interval", 1800);

                // todo 必须加上header说明  等房哥的企微
//                if (!wxConfig.sendAppTextCard(restTemplate, requestMap)) {
//                    wxConfig.sendAppTextCard(restTemplate, requestMap);
//                }
            }


    }

}
